import java.awt.*;
//
// forrit_0B_02
// Kvikindi
//
//
public abstract class Kvikindi extends Thread	
{	
	public double xhnit, yhnit, stefna;	// Allir hlutir sem 
	public Color litur;			// nota klasann kvik-
	public Color liturStriks;		// indi geta stjrna
	public boolean dregurStrik;		// stasetningu og 
																// stefnu kvikinda, 
	// lit eirra og v hvort au skilja eftir sig sl og 
	// hvernig hn er  litinn. ess vegna eru allar essar
	// breytur hafar public.

	protected Graphics myndflotur;		

	public Kvikindi(Graphics g)			// egar kvikindi 
	{						// er bi til fr 
		xhnit = 0;				// smiurinn sendan
		yhnit = 0;				// myndfltinn (.e.
		stefna = 0;				// hlut af teg. 
		myndflotur = g;				// Graphics sem
		liturStriks = new Color(0, 0, 0);	// kvkindi skal 
		litur = new Color(0, 0, 0);		// teikna .
		dregurStrik = false;
	}

	// Aferin fram notar aferirnar syna og fela sem
	// eru skilgreindar  undirklsum. Til a etta s
	// hgt vera r a vera til  Kvikindi. Afer sem 
	// er til  klasa en tfr  undirklsum kallast
	// abstract og er skilgreind eins og syna og fela hr
	// a nean.

	public void fram(double x)
	{
		double ny_xhnit, ny_yhnit;
	
		ny_xhnit = xhnit + x * Math.cos(stefna*Math.PI/180);
		ny_yhnit = yhnit - x * Math.sin(stefna*Math.PI/180);
		fela();
		if (dregurStrik) 
		{
			myndflotur.setPaintMode();
			myndflotur.setColor(liturStriks);
			myndflotur.drawLine((int)xhnit, (int)yhnit, 
								(int)ny_xhnit, (int)ny_yhnit);
		}
		xhnit = ny_xhnit;
		yhnit = ny_yhnit;
		syna();
	}

	public void haegri(double gradur)
	{
		fela();
		stefna = (stefna - gradur) % 360;
		syna();
	}

	public void vinstri(double gradur)
	{
		fela();
		stefna = (stefna + gradur) % 360;
		syna();
	}

	public abstract void syna();	// Hgt er a sna 
					// og fela ll kvik-
	public abstract void fela();	// indi en aferirnar
					// til ess eru mis-
// munandi eftir lgun kvikinda. Klasar eins og Padda ea
// Ormur sem erfa fr Kvikindi skilgreina snar eigin syna
// og fela aferir.
}
