import java.awt.*;
//
// forrit_0B_03
// Kvikindi
// Eins og  forrit_0B_02
// nema aferunum bida og rekstAVegg hefur veri 
// btt vi og allar agerir  myndfleti gerar
// synchronized.
//
public abstract class Kvikindi extends Thread	
{	
	public double xhnit, yhnit, stefna;	 
	public Color litur;
	public Color liturStriks;		
	public boolean dregurStrik;

	protected Graphics myndflotur;		

	public Kvikindi(Graphics g)				 
	{						
		xhnit = 0;			
		yhnit = 0;
		stefna = 0;	 
		myndflotur = g;
		liturStriks = new Color(0, 0, 0);	 
		litur = new Color(0, 0, 0);
		dregurStrik = false;
	}

	
	public void fram(double x)
	{
		double ny_xhnit, ny_yhnit;
		synchronized (myndflotur)	// Kemur  veg fyrir a arir
		{											// rir hafi hrif  mynd-
			// flt mean skipanablokk er framkvmd.
			ny_xhnit = xhnit + x * Math.cos(stefna*Math.PI/180);
			ny_yhnit = yhnit - x * Math.sin(stefna*Math.PI/180);
			fela();
			if (dregurStrik) 
			{
				myndflotur.setPaintMode();
				myndflotur.setColor(liturStriks);
				myndflotur.drawLine((int)xhnit, (int)yhnit, 
								(int)ny_xhnit, (int)ny_yhnit);
			}
			xhnit = ny_xhnit;
			yhnit = ny_yhnit;
			syna();
		}
	}

	public void haegri(double gradur)
	{
		synchronized (myndflotur)	// Kemur  veg fyrir a arir
		{											// rir hafi hrif  mynd-
			// flt mean skipanablokk er framkvmd.
			fela();
			stefna = (stefna - gradur) % 360;
			syna();
		}
	}

	public void vinstri(double gradur)
	{
		synchronized (myndflotur)	// Kemur  veg fyrir a arir
		{											// rir hafi hrif  mynd-
			// flt mean skipanablokk er framkvmd.
			fela();
			stefna = (stefna + gradur) % 360;
			syna();
		}
	}

	public abstract void syna();	
	public abstract void fela();	
	void bida(long t)
	{
		try {this.sleep(t);}
		catch (InterruptedException e) {}
	}

	public boolean rekstAVegg()
	{
		return	(xhnit < myndflotur.getClipRect().x + 5) || 
			(yhnit < myndflotur.getClipRect().y + 5) || 
			(xhnit > myndflotur.getClipRect().width - 5) ||
			(yhnit > myndflotur.getClipRect().height - 5);
	}
}
