import java.awt.*;
import java.util.Random;
//
// forrit_0B_03
// Padda
// Eins og  forrit_0A_01 nema aferinni run er btt vi.
// 
//
public class Padda extends Kvikindi
{
	private final int ab = 5;			// Radus afturbks
	private final int fb = 4;			// Radus frambks
	private final int h = 2;			// Radus hauss
	private final int fb_h = fb+h;		// Fjarlg fr mijum frambk
	private final int fb_ab = fb+ab-1;	//  mijan haus og fr mijum
										// frambk  mijan afturbk.

	private Hringur haus, fremriBukur, aftariBukur;
	
	public Padda(Graphics g)
	{
		super(g);	// Sendir smi yfirklasans Kvikindi g.
		// xhnit og yhnit sem Padda erfir fr Kvikindi eru mijan 
		// fremri bknum og t fr henni og stefnu drsins er
		// reikna t hvar mijan  hausnum og aftari bknum eiga 
		// a vera.
		float hausXhnit = Math.round(xhnit + 
 					fb_h * Math.cos(stefna*Math.PI/180));
 		float hausYhnit = Math.round(yhnit - 
 					fb_h * Math.sin(stefna*Math.PI/180));
 		float afturbuksXhnit = Math.round(xhnit - 
 					fb_ab * Math.cos(stefna*Math.PI/180));
 		float afturbuksYhnit = Math.round(yhnit + 
 					fb_ab * Math.sin(stefna*Math.PI/180));
		haus = new Hringur(h, hausXhnit, hausYhnit);
		fremriBukur = new Hringur(fb, xhnit, yhnit);
		aftariBukur = new Hringur(ab, afturbuksXhnit, afturbuksYhnit);
	}

	public void syna()
	{	
		fremriBukur.xHnitMidju = xhnit;
		fremriBukur.yHnitMidju = yhnit;
		haus.xHnitMidju = Math.round(xhnit + 
					fb_h * Math.cos(stefna*Math.PI/180));
		haus.yHnitMidju = Math.round(yhnit - 
					fb_h * Math.sin(stefna*Math.PI/180));
		aftariBukur.xHnitMidju = Math.round(xhnit - 
					fb_ab * Math.cos(stefna*Math.PI/180));
		aftariBukur.yHnitMidju = Math.round(yhnit + 
					fb_ab * Math.sin(stefna*Math.PI/180));
		myndflotur.setColor(litur);
		myndflotur.setXORMode(new Color(255,255,255));
		aftariBukur.syna(myndflotur);
		fremriBukur.syna(myndflotur);
		haus.syna(myndflotur);
	}
							
	public void fela()
	{
		syna();
	}

	public void run()
	{	
		double skreflengd;
		Random r = new Random();
		while (true)
		{	
			skreflengd = 3+r.nextGaussian();
			fram(skreflengd);
			if (rekstAVegg())
			{
				fram(-skreflengd);
				vinstri(180*r.nextGaussian());
			}
			vinstri(8*r.nextGaussian());
			bida(30);
		}
	}

}
