import java.awt.*;
//
// forrit_0E_01
// Trihyrningur
//
public class Trihyrningur extends Myndhluti implements Flotur, Ferill
{	
	protected Punktur p1, p2, p3;
	
	public Trihyrningur(Punktur a, Punktur b, Punktur c)
	{
		p1=a; p2=b; p3=c;
	}
	
	// Aferir sem tilheyra Myndhluti

	public void syna(Graphics g)
	{
		g.setColor(litur);
		g.drawLine((int)p1.x, (int)p1.y, (int)p2.x, (int)p2.y);
		g.drawLine((int)p2.x, (int)p2.y, (int)p3.x, (int)p3.y);
		g.drawLine((int)p3.x, (int)p3.y, (int)p1.x, (int)p1.y);
	}

	public void fela(Graphics g)
	{ 
		g.setColor(bakgrlitur);
		g.drawLine((int)p1.x, (int)p1.y, (int)p2.x, (int)p2.y);
		g.drawLine((int)p2.x, (int)p2.y, (int)p3.x, (int)p3.y);
		g.drawLine((int)p3.x, (int)p3.y, (int)p1.x, (int)p1.y);
	}

	// Afer sem tilheyrir Flotur

	public double flatarmal()
	{
		return 0.5*Math.abs(p1.x*p2.y + p2.x*p3.y + p3.x*p1.y 
						   -p1.x*p3.y - p2.x*p1.y - p3.x*p2.y);
	}

	// Afer sem tilheyrir Ferill
	// skilar samanlegri lengd riggja strika.
	public double ferillengd()
	{
		return Math.sqrt((p1.x - p2.x)*(p1.x - p2.x) + 
						 (p1.y - p2.y)*(p1.y - p2.y))
			 + Math.sqrt((p2.x - p3.x)*(p2.x - p3.x) + 
						 (p2.y - p3.y)*(p2.y - p3.y))
			 + Math.sqrt((p3.x - p1.x)*(p3.x - p1.x) + 
						 (p3.y - p1.y)*(p3.y - p1.y));
	}
}

