import java.awt.*;
import java.io.*;
//
// forrit_0F_02
// Textaskrar2
//
public class Textaskrar2 extends Frame	
{
	TextArea tTexti;
	Label  lTexti;
	Button bVista;
	Button bOpna;
	Button bHaetta;	
	
	FileDialog fdOpna, fdVista;
	
	public Textaskrar2(String titill)
	{													
		super(titill);
	}					
	
 	public void init()
	{
		FlowLayout fl = new FlowLayout();
		this.setLayout(fl);
		
		lTexti = new Label("Texti ");
		tTexti = new TextArea(10, 25);
		bVista = new Button("Vista");
		bOpna = new Button("Opna");
		bHaetta = new Button("Htta");
		
		this.add(lTexti); this.add(tTexti); 
		this.add(bVista); this.add(bOpna); 
		this.add(bHaetta);		
		
		// essar tegundir eru gluggar til a velja efniskr og skr.
		fdOpna  = new FileDialog(this, "Veldu skr til a opna.", FileDialog.LOAD);
		fdVista = new FileDialog(this, "Veldu skrnni sta og heiti.", FileDialog.SAVE);
	}

		
	public String lesaTextaskra(String skrNafn)
	{
		FileInputStream f;
		DataInputStream d;
		String allurTexti = "";
		String einLina;
		try
		{
			f = new FileInputStream(skrNafn);
			d = new DataInputStream(f);
			
			// Aferin available skila tlu sem segir hva
			// miki er eftir lesi  straumnum.
			while (d.available() != 0)
			{
				einLina = d.readLine();
				allurTexti = allurTexti + einLina + "\n";	
			}
			
			f.close();
			d.close();
		}
		catch (IOException fravik) 
		{ 
			// Binn til nr hlutur af tegundinni Villumelding.
			// Smiur hlutarins sr um a sna hann og hann sr
			// sjlfur um a fela sig egar smellt er  x-i 
			// horninu efst til hgri.
			Villumelding v = new Villumelding("Get ekki lesi " + skrNafn);
		}
		return allurTexti;
	}

	
	public void skrifaTextaskra(String skrNafn, String texti)
	{
		FileOutputStream f;
		PrintStream p;
		try
		{
			f = new FileOutputStream(skrNafn);
			p = new PrintStream(f);
			p.print(texti);
			f.close();
			p.close();
		}
		catch (IOException fravik) 
		{ 
			Villumelding v = new Villumelding("Get ekki skrifa " + skrNafn);
		}
 	}
	
	
	public boolean action(Event e, Object o)
	{
		if (e.target == bVista)
		{
			fdVista.show();
			if (fdVista.getFile() != null)
			{
				String skrNafn = fdVista.getDirectory() + fdVista.getFile();
				skrifaTextaskra(skrNafn, tTexti.getText());
				return true;
			}
			else 
		 	{
				return false;
			}
		}
		
		if (e.target == bOpna)
		{
			// Gluggi til a velja skr sndur. Hann sr sjlfur um a
			// fela sig egar smellt er  OK ea Cancel.
			fdOpna.show();
			
			// Ef smellt er  Cancel  skilar getFile gildinu null
			// sem merkir a engin skr hafi veri valin.
			if (fdOpna.getFile() != null)
			{
				String skrNafn = fdOpna.getDirectory() + fdOpna.getFile();
				tTexti.setText(lesaTextaskra(skrNafn));
				return true;
			}	
			else 
		 	{
				return false;
			}

		}

		if (e.target == bHaetta)	 			
		{	
			this.dispose(); 
			System.exit(0); 
			return true;
		}
		
		return false;
	}
}