import java.awt.*;
import java.applet.Applet;
import java.util.Random;
//
// Forrit_10_03
// NotkunHringaVektora 
//
public class NotkunHringaVektora extends Applet
{
	HringaVector v;
	Button bBuaTilHring;
	Button bUpp;
	Button bNidur;
	Button bHreinsa;
	Random r;
	
	public void init()
	{
		v = new HringaVector();
		r = new Random();
		bBuaTilHring = new Button("Ba til hring");
		bUpp = new Button("Upp");
		bNidur = new Button("Niur");
		bHreinsa = new Button("Hreinsa");
		this.add(bBuaTilHring);
		this.add(bUpp);
		this.add(bNidur);
		this.add(bHreinsa);
	}
	
	public void paint(Graphics g)
	{
		for(int i=0; i < v.size(); i++)
		{
			v.elementAt(i).syna(g);	
		}
	}
	
	public boolean action(Event e, Object o)
	{
		if (e.target == bBuaTilHring)
		{
			double radius = 5+20*r.nextDouble();
			double xhnit = 25+150*r.nextDouble();
			double yhnit = 25+150*r.nextDouble();
			v.addElement(new Hringur(radius, xhnit, yhnit));
			this.repaint();
			return true;
		}
		
		if (e.target == bUpp)
		{
			for(int i=0; i < v.size(); i++)
			{
				v.elementAt(i).yHnitMidju -= 5;	
			}
			this.repaint();
			return true;
		}
		
		if (e.target == bNidur)
		{
			for(int i=0; i < v.size(); i++)
			{
				v.elementAt(i).yHnitMidju += 5;	
			}
			this.repaint();
			return true;
		}
		
		if (e.target == bHreinsa)
		{
			v.removeAllElements();
			this.repaint();
			return true;
		}

		return false;
	}
}