import java.awt.*;
import java.net.*;
//
// Forrit_12_01
// FinnaIPTolu
// Finnur IP tlur ef umdmisheiti eru gefin.
//
public class FinnaIPTolu extends Frame
{
	// Klasinn InetAddress geymir umdmisheiti og
	// IP tlu tlvu  Internetinu.
	InetAddress thessiTolva, onnurTolva;
	Button bHaetta;	
	Button bFinnaIPTolu;
	Button bEiginIPTalaOgHeiti;
	TextField tUmdaemisheiti;
	TextField tIPTala;
	Label skilabod;
	

	FinnaIPTolu(String s)
	{
		super(s); 
	}
	
	public void init()
	{		
		FlowLayout f = new FlowLayout();
		this.setLayout(f);	
		bFinnaIPTolu = new Button("Finna IP-tlu.");
		bEiginIPTalaOgHeiti = new Button("Eigin IP-tala og heiti");
		bHaetta = new Button("Htta");
		tUmdaemisheiti = new TextField(20);
		tIPTala = new TextField(20);
		skilabod = new Label("Umdmisheiti m skrifa  efri reitinn");
		this.add(skilabod);
		this.add(tUmdaemisheiti);
		this.add(tIPTala);
		this.add(bFinnaIPTolu);
		this.add(bEiginIPTalaOgHeiti);
		this.add(bHaetta);
	}

	public boolean action(Event e, Object o)
	{
		if (e.target == bHaetta)
		{
			dispose();
			System.exit(0);
			return(true);
		}
		
		if (e.target == bFinnaIPTolu)
		{
			String umdaemisheiti = tUmdaemisheiti.getText();
			try
			{
				// InetAddress hefur engan public smi en  
				// stainn static aferina getByName sem 
				// tekur vi umdmisheiti sem streng og skilar
				// hlut af gerinni InetAddress.
				onnurTolva = InetAddress.getByName(umdaemisheiti);
				// Aferin getHostAddress finnur IP-tlu 
				// hlutar af gerinni InetAddress. Til a aferin
				// virki arf tlvan a vera  sambandi vi
				// Interneti v hn notar umdmisheitajnustu
				//  Internetinu til a finna hvaa IP-tala
				// samsvarar umdmisheitinu sem hluturinn 
				// ( essu tilviki onnurTolva) geymir.
				String ipTala = onnurTolva.getHostAddress();
				tIPTala.setText(ipTala);
			}
			catch (UnknownHostException ue)
			{
				tIPTala.setText("Finn ekki " + umdaemisheiti);
			}
			return true;
		}
		
				if (e.target == bEiginIPTalaOgHeiti)
		{
			try
			{
				// Aferin getLocalHost skilar hlut af
				// gerinni InetAddress sem inniheldur
				// umdmisheiti og ip-tlu tlvunnar
				// sem forriti er keyrt . Hn er static.
				thessiTolva = InetAddress.getLocalHost();
				String eiginIPTala = thessiTolva.getHostAddress();
				tIPTala.setText(eiginIPTala);
				// Aferin getHostName skilar umdmisheiti.
				// Hn er static eins og fleiri aferir 
				// klasanum InetAddress.
				String eigidUmdaemisheiti = thessiTolva.getHostName();
				tUmdaemisheiti.setText(eigidUmdaemisheiti);
			}
			catch (UnknownHostException ue)
			{
				tIPTala.setText("Er g  sambandi?");
			}
			return true;
		}
		return false;
	}
	
}