import java.awt.*;
import java.net.*;
import java.io.*;
//
// Forrit_12_04
// Midlari
//   Tekur vi skilaboum fr bilara eins og  forrit_12_05
// og birtir au  textareit og sendir svar til baka um a 
// skilabo hafi borist.
//   Sltur sambandi um lei og bilari sendir lnu sem  
// stendur "bless" og ekkert anna.
//
public class Midlari extends Frame
{
	// etta forrit  a svara boum sem berast  port nmer 9000.
	final int HLID = 9000;
	
	Button bHaetta;
	Label lUpplysingar, lFraBidlara;
	TextArea tFraBidlara, tUpplysingar;
	
	Midlari(String s)
	{
		super(s); 
	}
	
	public void init()
	{
		FlowLayout f = new FlowLayout();
		this.setLayout(f);	
		
		// Merki, takkar og textareitir smair og settir  skjinn.
		lFraBidlara = new Label("Bo fr bilara.");
		lUpplysingar = new Label("Upplsingar um gang mla.");
		bHaetta = new Button("Htta");
		tFraBidlara = new TextArea(10, 70);
		tUpplysingar = new TextArea(10, 70);
		
		this.add(tFraBidlara);
		this.add(lFraBidlara);
		this.add(tUpplysingar);
		this.add(lUpplysingar);
		this.add(bHaetta);
	}
			
	public void skrifaUpplysingarUmEiginIPToluHeitiOgHlid()
	{
		// Upplsingar um eigin IP tlu og umdmisheiti fundnar.
		try
		{
			InetAddress thessiTolva;
			thessiTolva = InetAddress.getLocalHost();
			String eiginIPTala = thessiTolva.getHostAddress();
			String eigidUmdaemisheiti = thessiTolva.getHostName();
			tUpplysingar.appendText("IP tala mn er: " + eiginIPTala + "\n");
			tUpplysingar.appendText("Umdmisheiti mitt er: " + eigidUmdaemisheiti + "\n");
			tUpplysingar.appendText("g tek vi boum sem berast  port nmer: " + HLID + "\n");
		}
		catch (UnknownHostException fravik)
		{
				tUpplysingar.appendText("Eitthva klikkai" + "\n" + fravik.toString() + "\n");
		}
	}
	
	
	public void tengjastOgTakaViBodum()
	{
		ServerSocket s;
		Socket tenging;
		DataInputStream dLesa;
		PrintStream pSenda;
		String lina;
		try
		{	
			s = new ServerSocket(HLID);
			tUpplysingar.appendText(s.toString() + "\n");

			// Aferin accept ltur ServerSocket ba eftir beini 
			// um tengingu fr bilara og br til Socket til a
			// tala vi bilara um lei og slk beini berst.
			tenging = s.accept	();
			tUpplysingar.appendText(tenging.toString() + "\n");

			// Straumar bnir til.
			pSenda = new PrintStream(tenging.getOutputStream());
			dLesa = new DataInputStream(tenging.getInputStream());
			
			// Skilabo fr bilara lesin og birt  tFraBidlara
			int linunumer = 1;
			do
			{
				lina = dLesa.readLine();
				tFraBidlara.appendText(lina + "\n");
				pSenda.print("Lna nmer " + linunumer + "mttekin." + "\n");
				linunumer++;
				// Aferin flush tryggir a a sem printLine 
				// sendi af sta fari strax alla lei en sitji 
				// ekki  biminni.
				pSenda.flush();
			} while(!lina.equals("bless"));
			tUpplysingar.appendText("Samskiptum loki." + "\n" + "Rf samband." + "\n");
			
			// Tenginar rofnar.
			tenging.close();
			s.close();
			pSenda.close();
			dLesa.close();
			tUpplysingar.appendText("Samband rofi.");
		}
		catch (IOException fravik)
		{
				tUpplysingar.appendText("Samband klikkai" + "\n" + fravik.toString() + "\n");
		}
		catch (Exception fravik)
		{
				tUpplysingar.appendText("Eitthva klikkai" + "\n" + fravik.toString() + "\n");
		}
	}
	
	
	public boolean action(Event e, Object o)
	{
		if (e.target == bHaetta)
		{
			dispose();
			System.exit(0);
			return true;
		}
		return false;
	}
}

// Ath. getur aeins veri  sambandi vi einn bilara.
// Ekki hgt a keyra mrg eintk samtmis.