import java.util.StringTokenizer;
//
// forrit_08_02
// Talnasafn
//
public class Talnasafn 
{
	private double[] t;
	private int fjoldiTalna;
	private int hamarksfjoldiTalna = 100;

	// ************ SMIIR ****************

	public Talnasafn()  			// Br til talnasafn me plss fyrir 
	{									// hamarksfjoldiTalna sem er 100.
		t = new double[hamarksfjoldiTalna];
		fjoldiTalna = 0;
	}

	public Talnasafn(int h) 	// Br til talnasafn me plss
	{									// fyrir h tlur.
		hamarksfjoldiTalna = h;
		t = new double[hamarksfjoldiTalna];
		fjoldiTalna = 0;
	}

 	// ************** AFER TIL A SETJA TLUR  SAFNI **********
	public void setjaTolurISafn(String s, String d)
	{
		StringTokenizer st;
		String sTala;
		Double Tala;
		fjoldiTalna = 0;
		st = new StringTokenizer(s, d);
		
		while ((st.hasMoreTokens()) && 
			   (fjoldiTalna < hamarksfjoldiTalna))
		{
			sTala = new String(st.nextToken()); 
			Tala = new Double(sTala);
			t[fjoldiTalna] = Tala.doubleValue();
			fjoldiTalna++;	
		}
	}

	// ************* REIKNIAFERIR *************

	public int fjoldi()
	{
		return fjoldiTalna;
	}

	public double summa()
	{
		int i;
		double summa = 0;
		for(i=0; i<fjoldiTalna; i++)
		{
			summa += t[i];
		}
		return summa;
	}

	public double medaltal()
	{
		return summa()/fjoldiTalna;
	}

	// a sem er hr fyrir nean er vibtur vi
	// klasann Talnasafn  forrit_06_03.

	public double midgildi()
	{
		rada();
		if ((fjoldiTalna % 2) == 1)	// Ef fjldinn er oddat.  
		{										// a skila mitlunni (ar 
			return t[fjoldiTalna/2];	// sem fyrsta t. er nr. 0 er 
		}										// mit. nr. fjoldiTalna/2)
												// annars  a skila mealt.
		else									// talnanna sitt hvoru megin
		{										// vi miju.
			return (t[fjoldiTalna/2 - 1] + t[fjoldiTalna/2])/2;
		}					
	}						
 	public double minnsta()
	{
		return t[fremstaTala(0, fjoldiTalna-1)];
	}

	public double staersta()
	{
		return t[aftastaTala(0, fjoldiTalna-1)];
	}

	public double sponn()	// Finnur muninn  hstu og 
	{								// lgstu tlu  talnasafni.
		return (staersta() - minnsta());
	}

	public double medalfv()	// Reiknar mealfrvik
	{
		int i;
		double s=0;
		double m = medaltal();
		for(i=0; i<fjoldiTalna; i++)
		{
			s += Math.abs(t[i] - m);
		}
		return s/fjoldiTalna;
	}

	public double fervik()
	{
		int i;
		double s = 0;
		double m = medaltal();
		for(i=0; i<fjoldiTalna; i++)
		{
			s += Math.pow((t[i]-m), 2);
		}
		return s/fjoldiTalna;
	}

	public double stdev()	// Reiknar staalfrvik
	{
		return Math.sqrt(fervik());
	}
	

	// **************** PRIVATE AFERIR *********************
	// Hr koma aferir sem raa talanasafni.
	// og finna minnstu og strstu tlu.

	private int aftastaTala(int upph, int endi)
	{
		int tilgata, i;
		tilgata = upph;
		
		for(i=upph+1; i<=endi; i++)
		{
			if (t[i] > t[tilgata])
			{
				tilgata = i;
			}
		}
		return tilgata;
	}
	
	private int fremstaTala(int upph, int endi)
	{
		int tilgata, i;
		tilgata = upph;
		
		for(i=upph+1; i<=endi; i++)
		{
			if (t[i] < t[tilgata])
			{
				tilgata = i;
			}
		}
		return tilgata;
	}
		
	private void rada()
	{
		int fremsta, i;
		double x;
		for(i=0; i<fjoldiTalna-1; i++)
		{
			fremsta = fremstaTala(i, fjoldiTalna-1); 
			x = t[i];
			t[i] = t[fremsta];
			t[fremsta] = x;
		}
	}
	// Hr lkur aferum til a raa talansafni.
	// og finna minnstu og strstu tlu.

}