import java.awt.*;
import java.util.Random;
//
// forrit_0B_02
// Bjalla
// Eins og Bjalla  forrit_0A_01 nema
// hr hefur run afer veri btt vi
// sem og aferunum rekstAVegg og bida.
// run notar java.util.Random svo 
// s klasi er fluttur inn hr fyrir ofan.
//
public class Bjalla extends Kvikindi
{
	private final int b = 5;	// Radus bks
	private final int h = 2;	// Radus hauss
	private final int s = b+h;	// Fjarlg fr mijum
					// bk  mijan haus.
	private Hringur haus, bukur;
	
	public Bjalla(Graphics g)
	{
		super(g);
		float hausXhnit = Math.round(xhnit + s * Math.cos(stefna*Math.PI/180));
		float hausYhnit = Math.round(yhnit - s * Math.sin(stefna*Math.PI/180));
		haus = new Hringur(h, hausXhnit, hausYhnit);
		bukur = new Hringur(b, xhnit, yhnit);
	}

	public void syna()  
	{	
		bukur.xHnitMidju = xhnit;
		bukur.yHnitMidju = yhnit;
		haus.xHnitMidju = Math.round(xhnit + s * Math.cos(stefna*Math.PI/180));
		haus.yHnitMidju = Math.round(yhnit - s * Math.sin(stefna*Math.PI/180));
		myndflotur.setColor(litur);
		myndflotur.setXORMode(new Color(255,255,255));
		bukur.syna(myndflotur);
		haus.syna(myndflotur);
	}
							
	public void fela()
	{
		syna();
	}

	// a sem er hr fyrir nean er vibt vi Bjalla  forrit_0A_01

	void bida(long t)
	{
		try {this.sleep(t);}
		catch (InterruptedException e) {}
	}

	public boolean rekstAVegg()
	{
		return	(xhnit < myndflotur.getClipRect().x + s) || 
			(yhnit < myndflotur.getClipRect().y + s) || 
			(xhnit > myndflotur.getClipRect().width - s) ||
			(yhnit > myndflotur.getClipRect().height - s);
	}

	public void run()
	{	
		double skreflengd;
		Random r = new Random();
		while (true)
		{	
			skreflengd = 2+r.nextGaussian();
			fram(skreflengd);
			if (rekstAVegg())
			{
				fram(-skreflengd);
				vinstri(180*r.nextGaussian());
			}
			vinstri(15*r.nextGaussian());
			bida(30);
		}
	}
}
