import java.awt.*;
//
// forrit_0C_02
// BjallaSemEturOrma
// 
// Finnur orma me v a taka 
// beygju um 30 til 45 grur til hgri
//  hvert sinn sem lykt af Ormum dofnar.
//
public class BjallaSemEturOrma extends Bjalla
{	
	private int hradi;
	private double styrkurLyktar;
	Slembitalnagjafi s;
	Kvikindi[] dyrASvaedinu;


	public BjallaSemEturOrma(Graphics g, Kvikindi[] k)
	{
		super(g);
		double f2;
		s = new Slembitalnagjafi();
		hradi = 3;
		dyrASvaedinu = k;
		styrkurLyktar = 0;
		for (int i=0; i<dyrASvaedinu.length; i++)
		{
			if (dyrASvaedinu[i] instanceof Ormur)
			{
				f2 = fjarlaegdI2Veldi(dyrASvaedinu[i]);
				if (f2 < 10000) // Lykt finnst ekki
				{				// ef fjarl. > 100.
					styrkurLyktar += 1/f2;
				}
			}
		}
	}

	public void run()
	{	
		double skreflengd;
		int nrOrms;
		while (true)
		{	
			skreflengd = 2*s.slembitala();
			fram(skreflengd);
			if (rekstAVegg())
			{
				fram(-skreflengd);
				vinstri(180-360*s.slembitala());
			}
			// Rsar tilviljanakennt um 0 til 15 
			// grur  hverju skrefi.
			vinstri(30*(0.5-s.slembitala()));

			// Beygir markvisst um 30 til 40 grur ef 
			// lykt af ormum dofnar.
			if (lyktAfOrmumDofnar())
			{
				haegri(30+15*s.slembitala());
			}
			nrOrms = ormurFundinn();
			if (nrOrms != -1) { etaOrm(nrOrms); }
			bida(100/hradi);
		}
	}

	private void etaOrm(int nr)
	{
		synchronized (myndflotur)
		{
			dyrASvaedinu[nr].fela();
			dyrASvaedinu[nr].stop();
			dyrASvaedinu[nr] = null;
		}
		styrkurLyktar = 0;
	}

	private int ormurFundinn()
	{
		int nr = -1;
		for (int i=0; i<dyrASvaedinu.length; i++)
		{
			if (dyrASvaedinu[i] instanceof Ormur)
			{
				if (50>fjarlaegdI2Veldi(dyrASvaedinu[i]))
				nr = i;
			}
		}
		return nr;
	}

	private double fjarlaegdI2Veldi(Kvikindi k)
	{
		return	(xhnit-k.xhnit)*(xhnit-k.xhnit) +
				(yhnit-k.yhnit)*(yhnit-k.yhnit);
	}

	private boolean lyktAfOrmumDofnar()
	{
		double f2;
		double fyrriStyrkur = styrkurLyktar;
		styrkurLyktar = 0;
		for (int i=0; i<dyrASvaedinu.length; i++)
		{
			if (dyrASvaedinu[i] instanceof Ormur)
			{
				f2 = fjarlaegdI2Veldi(dyrASvaedinu[i]);
				if (f2 < 1000)
				{
					styrkurLyktar += 1/f2;
				}
			}
		}
		return styrkurLyktar < fyrriStyrkur;
	}
}
