import java.applet.Applet;
import java.awt.*;
//
// forrit_0E_01
// Mynd2
//
//
public class Mynd2 extends Applet
{
	Flotur[] f;
	Button bStaekka, bMinnka;
	TextField tUtkoma;
	Graphics g;
	
	public void init()
	{
		bStaekka = new Button("Stkka");
		bMinnka = new Button("Minnka");
		this.add(bStaekka);
		this.add(bMinnka);
		tUtkoma = new TextField(28);
		this.add(tUtkoma);

		g = this.getGraphics();

		f = new Flotur[4];

		f[0] = new Trihyrningur(new Punktur(10, 180), 
								new Punktur(40, 180),
								new Punktur(25, 120));
		f[1] = new Hringur(new Punktur(120, 120), 30);
		f[2] = new Trihyrningur(new Punktur(60, 180), 
								new Punktur(100, 180),
								new Punktur(80, 100));
		f[3] = new Trihyrningur(new Punktur(120, 180), 
								new Punktur(190, 180),
								new Punktur(170, 110));
		tUtkoma.setText("Samanlagt flatarml er " + reiknaFlatarmal());
		
	}

	public void paint(Graphics g)
	{
		for(int i=0; i<f.length; i++)
		{
			if (f[i] != null)
			{
				((Myndhluti)f[i]).syna(g);
			}
		}
	}

	public double reiknaFlatarmal()
	{
		double samanlagtFlatarmal = 0;
		for(int i=0; i<f.length; i++)
		{
			samanlagtFlatarmal += f[i].flatarmal();
		}
		return	samanlagtFlatarmal;
				
	}

	public void minnka(Hringur h)
	{
		h.radius -= 5;
	}

	public void staekka(Hringur h)
	{
		h.radius += 5;
	}

	public void minnka(Trihyrningur t)
	{
		 t.p3.y += 5;	
	}

	public void staekka(Trihyrningur t)
	{
		 t.p3.y -= 5;	
	}


	public boolean action(Event e, Object o)
	{
		if (e.target == bStaekka)
		{
			for(int i=0; i<f.length; i++)
			{
				((Myndhluti)f[i]).fela(g);
				if (f[i] instanceof Hringur) 
				{ 
					staekka((Hringur)f[i]);
				}
				if (f[i] instanceof Trihyrningur) 
				{ 
					staekka((Trihyrningur)f[i]);
				}
				((Myndhluti)f[i]).syna(g);
			}
			tUtkoma.setText("Samanlagt flatarml er " + reiknaFlatarmal());
			return true;
		}

		if (e.target == bMinnka)
		{
			for(int i=0; i<f.length; i++)
			{
				((Myndhluti)f[i]).fela(g);
				if (f[i] instanceof Hringur) 
				{ 
					minnka((Hringur)f[i]);
				}
				if (f[i] instanceof Trihyrningur) 
				{ 
					minnka((Trihyrningur)f[i]);
				}
				((Myndhluti)f[i]).syna(g);
			}
			tUtkoma.setText("Samanlagt flatarml er " + reiknaFlatarmal());
			return true;
		}
		return false;
	}
}
