import java.awt.*;
import java.io.*;
//
// forrit_0F_01
// Textaskrar1
//
public class Textaskrar1 extends Frame	
{
	TextField tSkraarnafn;
	TextArea tTexti;
	Label lSkraarnafn, lTexti;
	Button bVista;
	Button bOpna;
	Button bHaetta;	

	// Smiurinn gerir ekkert anna en a kalla  
	// smi yfirtegundarinnar Frame.
	public Textaskrar1(String titill)
	{													
		super(titill);
	}					
	
 	public void init()
	{
		FlowLayout fl = new FlowLayout();
		this.setLayout(fl);
		
		lSkraarnafn = new Label("Nafn skrar ");
		tSkraarnafn = new TextField(25);
		lTexti = new Label("Texti ");
		tTexti = new TextArea(10, 25);
		bVista = new Button("Vista");
		bOpna = new Button("Opna");
		bHaetta = new Button("Htta");
		
		this.add(lSkraarnafn); this.add(tSkraarnafn); 
		this.add(lTexti); this.add(tTexti); 
		this.add(bVista); this.add(bOpna); 
		this.add(bHaetta);		
		
	}

	public String lesaTextaskra(String skrNafn)
	{
		// FileInputStream er tegund sem tekur vi 
		// r skr. DataInputStream tekur vi ggnum 
		// r rum straumi, hr FileInputStream.
		FileInputStream f;
		DataInputStream d;
		String allurTexti = "";
		String einLina;
		try
		{
			// FileInputStream binn til og hann stilltur 
			// a taka vi r skrnni sem nefnd er  skrNafn.
			f = new FileInputStream(skrNafn); 
			// DataInputStream binn til og hann stilltur  
			// a taka vi r strauminum f.
			d = new DataInputStream(f);
			
									
			// Aferin available skila tlu sem segir hva
			// miki er eftir lesi  straumnum.
			while (d.available() != 0)
			{
				einLina = d.readLine();
				allurTexti = allurTexti + einLina + "\n";		
			}
			
			// Skrfa fyrir strauma.
			f.close();
			d.close();
		}
		
		// Smiirnir FileInputStream og DataInputStream
		// og aferin readLine kasta frviki af tegundinni
		// IOException ef eitthva fer rskeiis.
		catch (IOException fravik) 
		{ 
			tSkraarnafn.setText("Get ekki lesi " + skrNafn);
		}
		
		// Aferin skilar streng sem er samsettur
		// r llu sem lesi var r skrnni.
		return allurTexti;
	}

	
	public void skrifaTextaskra(String skrNafn, String texti)
	{
		FileOutputStream f;
		PrintStream p;
		try
		{
			// FileOutputStream binn til og hann stilltur 
			// a skrifa  skrna sem nefnd er  skrNafn.
			f = new FileOutputStream(skrNafn);
			// PrintStream binn til og hann stilltur  
			// a skrifa  strauminn f.
			p = new PrintStream(f);
			
			// Innihald breytunnar texti skrifa  strauminn p.
			p.print(texti);
			// Skrfa fyrir strauma.			
			f.close();
			p.close();
		}
		// Smiurinn FileOutputStream kastar frviki af 
		// tegundinni IOException ef eitthva fer rskeiis.
		catch (IOException fravik) 
		{ 
			tSkraarnafn.setText("Get ekki skrifa " + skrNafn);
		}
	}
	
	public boolean action(Event e, Object o)
	{
		if (e.target == bVista)
		{
			skrifaTextaskra(tSkraarnafn.getText(), 
											tTexti.getText());
			return true;
		}
		
		if (e.target == bOpna)
		{
			tTexti.setText(lesaTextaskra(tSkraarnafn.getText()));
			return true;
		}


		if (e.target == bHaetta)	 			
		{	
			this.dispose(); 
			System.exit(0); 
			return true;
		}	
		return false;
	}
}

// Skipanirnar sem eru framkvmdar egar tt er  bHaetta
// eru skrar  9. kafla.