import java.awt.*;
import java.io.*;
//
// forrit_0F_03
// Textaskrar3
//
public class Textaskrar3 extends Frame	
{
	TextArea tTexti;
	Label  lTexti;
	Button bADulmal;
	Button bAfDulmali;
	Button bHaetta;	
	
	String efnisskra;  	// Geymir heiti eirrar efnisskrr sem 
											// skr var stt r sast. Er upphaflega 
											// null.
	
	FileDialog fdADulmalOpna, fdAfDulmaliOpna;

	
	public Textaskrar3(String titill)
	{													
		super(titill);
	}					
	
 	public void init()
	{
		FlowLayout fl = new FlowLayout();
		this.setLayout(fl);
		
		lTexti = new Label("Texti");
		tTexti = new TextArea(12, 30);
		bADulmal = new Button("Snara  dulml");
		bAfDulmali = new Button("Snara af dulmli");
		bHaetta = new Button("Htta");
		
		this.add(lTexti); this.add(tTexti); 
		this.add(bADulmal); this.add(bAfDulmali);
		this.add(bHaetta);		
		
		fdADulmalOpna  = new FileDialog(this, "Hvaa skr  a a  dulml?", FileDialog.LOAD);
		fdAfDulmaliOpna  = new FileDialog(this, "Hvaa dulmlsskr  a a?", FileDialog.LOAD);
	}

	
	public void snaraADulmal(String dir, String skr)
	{	
		FileOutputStream fSkrif;  // Skr sem skrifu er.
		DataOutputStream dSkrif;	// Gaganstraumur  fSkrif.
		FileInputStream fLes;			// Skr sem lesi er r.
		DataInputStream dLes;			// Gagnastraumur r fLes.
		
		int eittByte;							
		
		String skrNafn, nyttSkrNafn;
		
		// Vali nafn  skrna sem skrifa skal .
		// Hn fr sama fornafn og skrin sem lesi er
		// r en nafnaukann .dul.
		skrNafn = dir + skr;
		int i = skr.indexOf(".");					
		if (i == -1)  // Ef skr sem lesi er r hefur engan						
		{							// nafnauka er dul einfaldlega btt vi 
			nyttSkrNafn = dir + skr + ".dul"; // heiti hennar.
		}
		else
		{
			nyttSkrNafn = dir + skr.substring(0, i) + ".dul";
		}
		
		
		try
		{
			fLes = new FileInputStream(skrNafn);
			dLes = new DataInputStream(fLes);
			fSkrif = new FileOutputStream(nyttSkrNafn);
			dSkrif = new DataOutputStream(fSkrif);
	
			// Mean eitthva er enn lesi r dLes 
			// (gagnastraumnum sem rennur  r fLes)
			// er lesi eitt bti og skrifa  dSkrif.
			while (dLes.available() > 0) 
			{	
				// Hr er lesi r dLes
				eittByte = dLes.readUnsignedByte();
				
				// Hr er btinu sem lesi var breytt
				// me v a hkka gildi um 1.
				if (eittByte == 255)
				{
					eittByte = 0; 
				}
				else
				{
					eittByte += 1;
				}
				
				// Hr er bti skrifa  dSkrif.
				dSkrif.writeByte(eittByte);
				
				// Hr er btinu breytt  eins stfs streng og 
				// honum btt  textareit.
				tTexti.appendText(String.valueOf((char)eittByte));
			}
			
			// Skrfa fyrir strauma.
			fLes.close();
			dLes.close();
			fSkrif.close();
			dSkrif.close();
		}

		catch (IOException fravik) 
		{ 
			Villumelding v = new Villumelding("Get ekki snara " + skrNafn);
		}
	}
	
	// Nsta afer er nstum v eins og snaraADulmal.
	public void snaraAfDulmali(String dir, String skr)
	{
		FileOutputStream fSkrif;
		DataOutputStream dSkrif;
		FileInputStream fLes;
		DataInputStream dLes;
		int eittByte;
		String skrNafn, nyttSkrNafn;
		
		skrNafn = dir + skr;
		int i = skr.indexOf(".");							// Skiljanlg skr 
		if (i == -1)													// fr nafnaukann
		{																			// .ski
			nyttSkrNafn = dir + skr + ".ski";	
		}
		else
		{
			nyttSkrNafn = dir + skr.substring(0, i) + ".ski";
		}
		
		try
		{ 
			fLes = new FileInputStream(skrNafn);
			dLes = new DataInputStream(fLes);
			fSkrif = new FileOutputStream(nyttSkrNafn);
			dSkrif = new DataOutputStream(fSkrif);
	
			while (dLes.available() > 0) 
			{	
				eittByte = dLes.readUnsignedByte();
				if (eittByte == 0)
				{
					eittByte = 255;
				}
				else
				{
					eittByte -= 1;
				}
				dSkrif.writeByte(eittByte);
				tTexti.appendText(String.valueOf((char)eittByte));
			}
			
			fLes.close();
			dLes.close();
			fSkrif.close();
			dSkrif.close();
		}

		catch (IOException fravik) 
		{ 
			Villumelding v = new Villumelding("Get ekki snara " + skrNafn);
		}
	}
	
	
	public boolean action(Event e, Object o)
	{
		
		if (e.target == bADulmal)
		{	
			if (efnisskra != null)    // Ef breytan efnisskra hefur
			{ 												// fengi gildi.
				fdADulmalOpna.setDirectory(efnisskra); 
			}
			fdADulmalOpna.show();
			if (fdADulmalOpna.getFile() != null) 	// Ef einhver 
			{																			// skr var valin
				tTexti.setText("");																	
				efnisskra = fdADulmalOpna.getDirectory();
				snaraADulmal(fdADulmalOpna.getDirectory(), fdADulmalOpna.getFile());
				return true;
			}
			else 
			{
				return false;
			}
		}

		if (e.target == bAfDulmali)
		{
			if (efnisskra != null) 
			{ 
				fdAfDulmaliOpna.setDirectory(efnisskra); 
			}
			fdAfDulmaliOpna.show();
			if (fdAfDulmaliOpna.getFile() != null)
			{
				tTexti.setText("");
				efnisskra = fdAfDulmaliOpna.getDirectory();
				snaraAfDulmali(fdAfDulmaliOpna.getDirectory(), fdAfDulmaliOpna.getFile());
				return true;
			}
			else 
			{
				return false;
			}
		}

		if (e.target == bHaetta)	 			
		{	
			this.dispose(); 
			System.exit(0); 
			return true;
		}	
		return false;
	}
}