import java.awt.*;
import java.io.*;
import java.util.StringTokenizer;
//
// forrit_0F_04
// TextaOgTalnaskrar1
// Byggt  klasanum Textaskrar3  forrit_0F_03
//
public class TextaOgTalnaskrar1 extends Frame	
{
	Button bText2Int;
	Button bInt2Text;
	Button bHaetta;	
	
	String efnisskra;  	// Geymir heiti eirrar efnisskrr sem 
											// skr var stt r sast. Er upphaflega 
											// null.
	
	FileDialog fdText2IntOpna, fdInt2TextOpna;

	
	public TextaOgTalnaskrar1(String titill)
	{													
		super(titill);
	}					
	

	public void init()
	{
		FlowLayout fl = new FlowLayout();
		this.setLayout(fl);
		
		bText2Int = new Button("Breyta texta  tlur.");
		bInt2Text = new Button("Breyta tlum  texta.");
		bHaetta = new Button("Htta");
		
		this.add(bText2Int); this.add(bInt2Text);
		this.add(bHaetta);		
		
		fdText2IntOpna  = new FileDialog(this, "Hvaa textaskr  a breyta  talnaskr?", FileDialog.LOAD);
		fdInt2TextOpna  = new FileDialog(this, "Hvaa talnaskr  a breyta  textaskr?", FileDialog.LOAD);
	}

	public String finnaNyttSkrNafn(String dir, String skr, String nyrNafnauki)
	{
		String nyttSkrNafn;
		int i = skr.indexOf(".");					
		if (i == -1)  // Ef skr sem lesi er r hefur engan						
		{							// nafnauka er njum Nafnauka einfald-
									// lega btt vi heiti hennar.
			nyttSkrNafn = dir + skr + nyrNafnauki; 
		}
		else
		{
			nyttSkrNafn = dir + skr.substring(0, i) + nyrNafnauki;
		}
		return nyttSkrNafn;
	}
		
	
	// essi afer les textaskr sem inniheldur nfn  heilum 
	// tlum og breytir henni  skr af int-tlum.
	public void text2int(String dir, String skr)
	{	
		FileOutputStream fSkrif;  // Skr sem skrifu er.
		DataOutputStream dSkrif;	// Gaganstraumur  fSkrif.
		FileInputStream fLes;			// Skr sem lesi er r.
		DataInputStream dLes;			// Gagnastraumur r fLes.
		
		StringTokenizer st;
		String biltakn = " ,\t\n\r";  // Tkn sem geta agreint 
		String sTala;									// tvr tlur  textaskrnni
		Integer Tala;									// eru bil, komma, \t, \n, og \r.
		
		String einLina;							
		
		String skrNafn, nyttSkrNafn;
		
		skrNafn = dir + skr;
		nyttSkrNafn = finnaNyttSkrNafn(dir, skr, ".int");
		
		try
		{
			fLes = new FileInputStream(skrNafn);
			dLes = new DataInputStream(fLes);
			fSkrif = new FileOutputStream(nyttSkrNafn);
			dSkrif = new DataOutputStream(fSkrif);
	
			// Mean eitthva er enn lesi r dLes 
			// (gagnastraumnum sem rennur  r fLes)
			// er lesin ein lna, stengnum breytt  
			// heiltlur og skrifa  dSkrif.
			while (dLes.available() > 0) 
			{	
				// Hr er ein lna lesin r dLes
				einLina = dLes.readLine();
				st = new StringTokenizer(einLina, biltakn);
			
				// Hr er lnunni breytt  heiltlur
				// af gerinni int og r skrifaar  dSkrif.
				while (st.hasMoreTokens()) 
				{
					sTala = new String(st.nextToken()); 
					try	
					{
						Tala = new Integer(sTala);
						dSkrif.writeInt(Tala.intValue());
					}
					catch (NumberFormatException nfFravik) 
					{ 
						Villumelding v = new Villumelding(sTala + " er ekki tala.");
					}
				}	// while ((st.hasMoreTokens()) endar
			} // while (dLes.available() > 0) endar
			
			// Skrfa fyrir strauma.
			fLes.close();
			dLes.close();
			fSkrif.close();
			dSkrif.close();
		} // try blokk endar

		catch (IOException fravik) 
		{ 
			Villumelding v = new Villumelding("Get ekki snara " + skrNafn);
		}
	}
	
	
	
	// essi afer les skr me heiltlum af gerinni int
	// og breytir henni  textaskr a sem tlurnar eru
	// ritaar me kommu og bili  milli.
	public void int2text(String dir, String skr)
	{
		FileOutputStream fSkrif;
		PrintStream pSkrif;     // PrintStream nota til a 
		FileInputStream fLes;		// skrifa textaskr.
		DataInputStream dLes;
		
		int einTala;
		
		String skrNafn, nyttSkrNafn;
		
		skrNafn = dir + skr;
		nyttSkrNafn = finnaNyttSkrNafn(dir, skr, ".txt");
		
		try
		{ 
			fLes = new FileInputStream(skrNafn);
			dLes = new DataInputStream(fLes);
			fSkrif = new FileOutputStream(nyttSkrNafn);
			pSkrif = new PrintStream(fSkrif);
	
			while (dLes.available() > 0) 
			{	
				einTala = dLes.readInt();
				pSkrif.print(einTala + ", "); 
			}
			
			fLes.close();
			dLes.close();
			fSkrif.close();
			pSkrif.close();
		}

		catch (IOException fravik) 
		{ 
			Villumelding v = new Villumelding("Get ekki snara " + skrNafn);
		}
	}
	
	
	public boolean action(Event e, Object o)
	{
		
		if (e.target == bText2Int)
		{	
			if (efnisskra != null)    // Ef breytan efnisskra hefur
			{ 												// fengi gildi.
				fdText2IntOpna.setDirectory(efnisskra); 
			}
			
			fdText2IntOpna.show();
			
			if (fdText2IntOpna.getFile() != null) 	// Ef einhver 
			{																				// skr var valin
				efnisskra = fdText2IntOpna.getDirectory();
				text2int(fdText2IntOpna.getDirectory(), fdText2IntOpna.getFile());
				return true;
			}
			else 
			{
				return false;
			}
		}

		if (e.target == bInt2Text)
		{
			if (efnisskra != null) 
			{ 
				fdInt2TextOpna.setDirectory(efnisskra); 
			}
			
			fdInt2TextOpna.show();
			
			if (fdInt2TextOpna.getFile() != null)
			{
				efnisskra = fdInt2TextOpna.getDirectory();
				int2text(fdInt2TextOpna.getDirectory(), fdInt2TextOpna.getFile());
				return true;
			}
			else 
			{
				return false;
			}
		}

		if (e.target == bHaetta)	 			
		{	
			this.dispose(); 
			System.exit(0); 
			return true;
		}	
		return false;
	} // Hr endar action aferin.
}