import java.awt.*;
import java.net.*;
import java.io.*;
//
// forrit_12_02
// KannaURL
//
public class KannaURL extends Frame
{
	Button bHaetta;	
	Button bLesaURL;
	Button bUpplysingarUmURL;
	TextField tURL;
	TextField tTilCGIForrits; 	// Strengur sem arf a ka
	TextArea tSvar;					
	Label skilabod1;
	Label skilabod2;

	KannaURL(String s)
	{
		super(s); 
	}
	
	public void init()
	{		
		FlowLayout f = new FlowLayout();
		this.setLayout(f);	
		bLesaURL = new Button("Skja ggn");
		bUpplysingarUmURL = new Button("Upplsingar um URL");
		bHaetta = new Button("Htta");
		tURL = new TextField(40);
		tTilCGIForrits = new TextField(70);
		tSvar = new TextArea(15, 70);
		skilabod1 = new Label("Skrifau URL hr");
		skilabod2 = new Label("Ef URL vsar  CGI-bin forrit fr a strenginn sem er hr.");
		this.add(skilabod1);
		this.add(tURL);
		this.add(skilabod2);
		this.add(tTilCGIForrits);
		this.add(bLesaURL);
		this.add(bUpplysingarUmURL);
		this.add(bHaetta);
		this.add(tSvar);
	}

	void lesaGognFraURL(String s, TextArea t)		// Les skrna sem
	{																			// s vsar  og 
		DataInputStream dLes;									// skrifar inni-
		URL u;																// hald hennar  t.
		try
		{ 
			u = new URL(s);
			// openStream  klasanum URL br til straum r veffangi.
			dLes = new DataInputStream(u.openStream());
			String lina = dLes.readLine();
			while (lina != null) 
			{	
				t.appendText(lina + "\n");
				lina = dLes.readLine();
			}
			dLes.close();
		}
		// Smiurinn URL kastar frviki af tegundinni
		// MalformedURLException sem er undirklasi 
		// IOException. 
		//   Klasinn Villumelding r forrit_0F_03 er 
		// notaur til a birta skilabo ef frviki er
		// kasta.
		catch (MalformedURLException fravik) 
		{
			Villumelding v = new Villumelding("Rangt mynda URL");
		}
		// Aferin readLine kastar IOException.
		catch (IOException fravik) 
		{ 
			Villumelding v = new Villumelding(fravik.toString());
		}
		catch (Exception fravik) 
		{ 
			Villumelding v = new Villumelding(fravik.toString());
		}
	}

	void skrifaUpplUmURL(String s, TextArea t) 	// Hlutar URL sem er
																				// skrifa  s sundur
	{																			//  parta og skrifar
		InetAddress tolva;											// upplsingar um 
		URL u;																//  t.
		try
		{
			u = new URL(s);
			t.appendText("URL = " + u + "\n");
			t.appendText("Samskiptastaallinn er = " + u.getProtocol() + "\n");
			t.appendText("Umdmisheiti vefjns = " + u.getHost() + "\n");
			
			// Klasinn InetAddress sem kynntur var  forrit_12_01
			// er hr notaur til a finna IP tlu vefjns.
			tolva = InetAddress.getByName(u.getHost());
			String ipTala = tolva.getHostAddress();
			t.appendText("IP tala vefjns = " + ipTala + "\n");
			
			t.appendText("Porti er = " + u.getPort() + "\n");
			t.appendText("Skrin er = " + u.getFile() + "\n");
			t.appendText("Akkeri er = " + u.getRef() + "\n");
		}
		
		// Smiurinn URL kastar frviki af tegundinni
		// MalformedURLException sem er undirklasi 
		// IOException. 
		//   Klasinn Villumelding r forrit_0F_03 er 
		// notaur til a birta skilabo ef frviki er
		// kasta.
		catch (MalformedURLException fravik) 
		{
			Villumelding v = new Villumelding("Rangt mynda URL.");
		}
		catch (UnknownHostException ue)
		{
				Villumelding v = new Villumelding("Vefjnn finnst ekki.");
		}
	}
	

	public boolean action(Event e, Object o)
	{
		String URLStrengur;
		String tilCGIStrengur;
		
		if (e.target == bHaetta)
		{
			dispose();
			System.exit(0);
			return(true);
		}
		
		if (e.target == bLesaURL)
		{
			// Innihald textareita sett  strengjabreytur.
			URLStrengur = tURL.getText();
			tilCGIStrengur = tTilCGIForrits.getText();
			
			// Ef seinni textareiturinn er ekki tmur,
			// .e. ef senda  kaan streng til 
			// CGI-bin forrits,  er hann kaur og 
			// skeytt aftan vi fyrri strenginn (sem 
			// geymir URL og ? og einhverja skipun til 
			// CGI-bin forrits.
			if (tilCGIStrengur.length() > 0)
			{
				tilCGIStrengur = URLEncoder.encode(tilCGIStrengur);
				URLStrengur += tilCGIStrengur;
			}
			tSvar.setText("");
			
			// Strengurinn sem sendur verur aferinni
			// lesaGognFraURL birtur  seinni texta
			// reitnum (eim sem skrifa er  hva
			// senda skal CGI-bin forriti).
			tTilCGIForrits.setText(URLStrengur);
			lesaGognFraURL(URLStrengur, tSvar);
			return true;
		}
			
		if (e.target == bUpplysingarUmURL)
		{
			tSvar.setText("");
			URLStrengur = tURL.getText();
			skrifaUpplUmURL(URLStrengur, tSvar);
			return true;
		}
		return false;
	}
	
}

// A leita a "Akranes"  Alta Vista:
// http://www.altavista.com/cgi-bin/query?q=Akranes
// Til a leita a "Flateyri vi nundarfjr"  smu
// leitarvl er ekki sent:
// http://www.altavista.com/cgi-bin/query?q=Flateyri vi nundarfjr
// heldur:
// http://www.altavista.com/cgi-bin/query?q=Flateyri+vi%F0+%D6nundarfj%F6r%F0
//  fyrri reitinn er  skrifa:
// http://www.altavista.com/cgi-bin/query?q=
// og  ann seinni:
// Flateyri vi nundarfjr
//
// A leita a "Akranes"  Lycos:
// http://www.lycos.com/cgi-bin/pursuit?query=Akranes
//
// A leita a Akranes  InfoSeek:
// http://infoseek.go.com//Titles?qt=Akranes
// 
// A leita a Atli hararson  netfangaskr ISnet:
// http://www.isnet.is/cgi-bin/whois-is?Atli+Har%F0arson
//
// Verkefni forrit sem flettir upp  netfangaskr ISnet.