import java.awt.*;
import java.net.*;
import java.io.*;
//
// Forrit_12_05
// Bidlari
// Sendir vi skilabo til milara eins og  forrit_12_04.
// Sltur samband me v a senda lnu sem  stendur 
// "bless" og ekkert anna.
//
public class Bidlari extends Frame
{
	// Tengi og straumar eru klasabreytur v essi hlutir 
	// eru notair af mrgum aferum (tengjast, sendaSkilabod 
	// og rjufaSamband).  milaranum (forrit_12_04) eru samsvarandi 
	// hlutir stavrir v eir eru aeins notair af einni
	// afer sem er tengjastOgTakaViBodum.
	Socket tenging;
	DataInputStream dLesa;
	PrintStream pSenda;
	
	// Boolean breyta sem geymir upplsingar um hvort samband er 
	// ea ekki. Hefur upphafelga gildi false en fr gildi true um
	// lei og samband kemst  og aftur gildi false egar a rofnar.
	boolean iSambandi = false;
	
	// Snilegir hlutir r java.awt
	Label lIPTalaMidlara, lHlidMidlara;
	TextField tIPTalaMidlara, tHlidMidlara;
	Button bHaetta;
	Button bTengjast;
	Button bSendaSkilabod;
	Label lSkilabod, lFraMidlara, lUpplysingar;
	TextArea tSkilabod, tFraMidlara, tUpplysingar;
	
	Bidlari(String s)
	{
		super(s); 
	}
	
	public void init()
	{
		FlowLayout f = new FlowLayout();
		this.setLayout(f);	
		
		// Merki, takkar og textareitir smair og settir  skjinn.
		lIPTalaMidlara = new Label("IP tala milara");
		lHlidMidlara = new Label("Nmer hlis  milara");;
		
		tIPTalaMidlara = new TextField(15); 
		tHlidMidlara = new TextField(5);
		
		lSkilabod = new Label("Skilabo til milara");
		lFraMidlara = new Label("Svr fr milara.");
		lUpplysingar = new Label("Upplsingar um gang mla.");
	
		tSkilabod = new TextArea(7, 70);
		tFraMidlara = new TextArea(4, 70);
		tUpplysingar = new TextArea(4, 70);
		
		bTengjast = new Button("Tengjast");
		bSendaSkilabod = new Button("Senda skilabo");
		bHaetta = new Button("Htta");
		
		this.add(lIPTalaMidlara); this.add(	tIPTalaMidlara);
		this.add(lHlidMidlara); this.add(tHlidMidlara);
		this.add(bTengjast);
		this.add(tSkilabod); this.add(lSkilabod); 
		this.add(bSendaSkilabod);
		this.add(tFraMidlara); this.add(lFraMidlara);
		this.add(tUpplysingar); this.add(lUpplysingar);
		this.add(bHaetta);
	}
		
	
	public void tengjast()
	{
		String sIPTalaMidlara = tIPTalaMidlara.getText();
		// Streng  thlidMidlara breytt heiltlu af teg. int.
		Integer I = Integer.valueOf(tHlidMidlara.getText());
		int hlidMidlara = I.intValue();
		try
		{	
			// 
			InetAddress midlari = InetAddress.getByName(sIPTalaMidlara);
			tenging = new Socket(midlari, hlidMidlara);
			tUpplysingar.appendText("Samband er komi " + "\n");
			tUpplysingar.appendText(tenging.toString() + "\n");

			// Straumar bnir til.
			pSenda = new PrintStream(tenging.getOutputStream());
			dLesa = new DataInputStream(tenging.getInputStream());
			iSambandi = true;
		}

		catch (UnknownHostException fravik)
		{
			tUpplysingar.appendText("Milari finnst ekki" + "\n" + fravik.toString() + "\n");
		}

		catch (IOException fravik)
		{
			tUpplysingar.appendText("Ekki tkst a n sambandi" + "\n" + fravik.toString() + "\n");
		}

		catch (Exception fravik)
		{
			tUpplysingar.appendText("Eitthva klikkai" + "\n" + fravik.toString() + "\n");
		}
	}
	
	public void sendaSkilabod()
	{
		try
		{
			String sSkilabod = tSkilabod.getText();	
			pSenda.print(sSkilabod + "\n");
			pSenda.flush();
			String lina = dLesa.readLine();
			tFraMidlara.appendText(lina + "\n");
			if (sSkilabod.equals("bless"))
			{
				rjufaSamband();	
			}
		}
		catch (IOException fravik)
		{ // readLine  DataInputStream kastar IOException.
			tUpplysingar.appendText("Ekki barst svar fr milara" + "\n" + fravik.toString() + "\n");
		}
		catch (Exception fravik)
		{
			tUpplysingar.appendText("Eitthva klikkai" + "\n" + fravik.toString() + "\n");
		}

	}
	
	public void rjufaSamband()
	{
		try
		{
			dLesa.close();
			pSenda.close();
			tenging.close();	
		}
		catch (IOException fravik)
		{ 
			tUpplysingar.appendText("Ekki tkst a loka straumum og tengingu." + "\n" + fravik.toString() + "\n");
		}
		finally
		{
			iSambandi = false;
		}
	}
	
	
	public boolean action(Event e, Object o)
	{
		if (e.target == bTengjast)
		{
			if (!iSambandi) 
			{
				tengjast();
			}
			return true;
		}

		if (e.target == bSendaSkilabod)
		{
			if (iSambandi) 
			{
				sendaSkilabod();
			}
			return true;
		}

		if (e.target == bHaetta)
		{
			if (iSambandi) 
			{
				rjufaSamband();
			}
			dispose();
			System.exit(0);
			return true;
		}
		return false;
	}
}
